var EC, rdex, rdexf, ddf,pdf,rdf,dd,pd,rd, de, dy, dc, Q, logQ, u, f, s, dyf, dcf, Qf, logQf, uf, ff, m, mf, rf, rff, px, pc, Edc, Edcf;
varexo ec, ecf, ex, exf;  
  
parameters pdbar, lever, del, theta, gam, ies, mu, rho, alpha, kappa, sbar, ubar,Qbar,logQbar,fbar,rfbar,mu2bar,rho_vecm;  
// parameters  
gam   = 5.000000e+00;  
ies   = 1.000000e+00;  
del   = 9.600000e-01;  
theta = 1/(1-gam);  
mu    = 0.000000e+00;  
rho   = 1.000000e+00;  
rho_vecm   = 5.000000e-04;  
alpha = 9.700000e-01;  
lever = 1.010000e+00;  
kappa = alpha/(1-alpha);  
// Steady-State values  
sbar    = 0;  
ubar    = del/(1-del)*mu;  
Qbar    = exp((ubar+mu)*(1-gam));  
logQbar = log(Qbar);  
fbar    = log(((1+1/(kappa*exp(sbar)))^(-alpha))*((1+kappa/exp(sbar))^(alpha-1)));  
rfbar   = -log(del) + mu/ies;  
pdbar   = log(exp(-rfbar+mu)/(1-exp(-rfbar+mu)));  
mu2bar   = exp(sbar)/(1+exp(sbar));  
  
model;  
// Home and foreign good--endowments   
dy  = mu + ec + rho_vecm*EC;      
dyf = mu + ecf - rho_vecm*EC;   
// EC = Error Correction 
EC  = (1-2*rho_vecm) * EC(-1)  + ecf - ec;      
// Dividends cash-flows 
Edc  =  (dc(+1)-mu);  
Edcf = (dcf(+1)-mu);  
dd   = mu + Edc(-1) + .1*(dc-mu-Edc(-1));  
ddf  = mu + Edc(-1) + .1*(dc-mu-Edc(-1));
// Home- and Foreign-consumer share of endowments  
f  = log(1 + 1/(kappa*exp(s)))*(-alpha) +log(1+kappa/exp(s))*(alpha-1);  
ff = log(1 + kappa*exp(s))*(alpha-1) + log(1+exp(s)/kappa)*(-alpha);  
// Ready to define Home- and Foreign-consumption growth  
dc  = alpha*dy + (1-alpha)*dyf + f - f(-1);  
dcf = alpha*dyf + (1-alpha)*dy  + ff - ff(-1);  
//Home- and Foreign- certaint equivalent and utility  
u  = del*theta*logQ;   
uf = del*theta*logQf;  
  
Q    = exp((u(+1)+dc(+1))*(1-gam));  
logQ = log(Q);  
  
Qf    = exp((uf(+1)+dcf(+1))*(1-gam));  
logQf = log(Qf);  
  
s  = s(-1) + (u+dc)*(1-gam) - logQ(-1) - (uf+dcf)*(1-gam) + logQf(-1);  
de =  ec; //This eq is just to have a "de" variable 
  
exp(m) = del*exp(- dc/ies)*exp((u+dc)*(1-gam))/exp(logQ(-1));  
exp(mf) = del*exp(- dcf/ies)*exp((uf+dcf)*(1-gam))/exp(logQf(-1));  
  
1/exp(rf) = exp(m(+1));  
1/exp(rff) = exp(mf(+1));  
1 = exp(m(+1)+rd(+1));  
exp(rd) = (1+exp(pd))/exp(pd(-1))*exp(dd);  
1 = exp(mf(+1)+rdf(+1));  
exp(rdf) = (1+exp(pdf))/exp(pdf(-1))*exp(ddf);  
rdex = rd - rfbar; // This eq is just to have a "rdex" variable  
rdexf = rdf - rfbar; // This eq is just to have a "rdex" variable  
// For the referee  
exp(px) = exp(m(+1)+log(1+exp(px(+1))) + dy(+1) ) ;  
exp(pc) = exp(m(+1) + log(1+exp(pc(+1))) + dc(+1)) ;  
end;  
  
initval;  
dy=mu;  
dyf=mu;  
de=0;  
dc=mu;  
dcf=mu;  
EC=0;  
Edc=0;  
Edcf=0;  
dd=mu;  
ddf=mu;  
Q = Qbar;  
Qf = Qbar;  
logQ = logQbar;  
logQf = logQbar;  
u  = ubar;  
uf = ubar;  
f  = fbar;  
ff = fbar;  
s = 0;  
px = pdbar;  
pc = pdbar;  
pd = pdbar;  
rd = rfbar;  
rdex = 0;  
rdexf = 0;  
pdf = pdbar;  
rdf = rfbar;  
rf = rfbar;  
rff = rfbar;  
m  = -rfbar;  
mf = -rfbar;  
end;  
  
vcov = [3.496900e-04	1.223915e-04	0	0  
        1.223915e-04	3.496900e-04	0	0  
        0	0  0.000000e+00  0.000000e+00  
        0	0  0.000000e+00  0.000000e+00  ];
  
 order = 3.000000; 
