var rdex, ddf,pdf,rdf,dd,pd,rd, de, dy, dc, Q, logQ, u, x, f, s, dyf, dcf, Qf, logQf, uf, xf, ff, m, mf, rf, rff;
varexo ec, ecf, ex, exf;  
  
parameters xbar, jump, ire, pre, pdbar, lever, del, theta1, theta2, gam1, gam2,ies1,ies2, mu, rho, alpha1,alpha2, kappa1, kappa2, sbar, ubar,ubarf,Qbar1,logQbar1,Qbar2,logQbar2,fbar,ffbar,rfbar,rfbarf,mu2bar; 
// parameters  
gam1   = 5.000000e+00;  
gam2   = 5.000000e+00;  
ies1   = 2.000000e-01;  
ies2   = 2.000000e-01;  
del   = 9.600000e-01;  
theta1= 1;  
theta2= 1;  
mu    = 0.000000e+00;  
rho   = 9.000000e-01;  
alpha1 = 9.700000e-01;  
alpha2 = 9.500000e-01;  
lever = 1.010000e+00;  
pre = 1.880000e+00;  
ire = 1.000000e+05;  
jump = 4.000000e-01;  
kappa1 = alpha1/(1-alpha2);  
kappa2 = alpha2/(1-alpha1);  
// Steady-State values  
sbar = -1.147000e-01;  
ubar  = log((1-del)/(1-del*exp((1-1/ies1)*mu)))*(1/(1-1/ies1));  
ubarf  = log((1-del)/(1-del*exp((1-1/ies2)*mu)))*(1/(1-1/ies2));  
Qbar1    = exp((ubar+mu)*(1-gam1));  
Qbar2    = exp((ubarf+mu)*(1-gam2));  
logQbar1 = log(Qbar1);  
logQbar2 = log(Qbar2);  
fbar    = log(1 + 1/(kappa1*exp(sbar)))*(-alpha1) +log(1+kappa2/exp(sbar))*(alpha1-1);  
ffbar   = log(1 + kappa1*exp(sbar))*(alpha2-1) + log(1+exp(sbar)/kappa2)*(-alpha2);  
rfbar   = -log(del) + mu/ies1;  
rfbarf   = -log(del) + mu/ies2;  
pdbar   = log(exp(-rfbar+mu)/(1-exp(-rfbar+mu)));  
mu2bar   = exp(sbar)/(1+exp(sbar));  
xbar    = 0;  
  
model;  
// Home and foreign good--endowments   
dy  = mu + x(-1)  + ec;      
dyf = mu + xf(-1) + ecf;     
x   = rho*x(-1)   + (rho-1)*ec;  
xf  = rho*xf(-1)  + (rho-1)*ecf;  
// Dividends cash-flows 
dd  = mu+lever*(dc-mu);  
ddf  = mu+lever*(dcf-mu);
// Home- and Foreign-consumer share of endowments  
f  = log(1 + 1/(kappa1*exp(s)))*(-alpha1) +log(1+kappa2/exp(s))*(alpha1-1);  
ff = log(1 + kappa1*exp(s))*(alpha2-1) + log(1+exp(s)/kappa2)*(-alpha2);  
// Ready to define Home- and Foreign-consumption growth  
dc  = alpha1*dy + (1-alpha1)*dyf + f - f(-1);  
dcf = alpha2*dyf + (1-alpha2)*dy  + ff - ff(-1);  
//Home- and Foreign- certaint equivalent and utility  
exp((1-1/ies1)*u)=(1-del)+del*(Q^theta1);  
exp((1-1/ies2)*uf)=(1-del)+del*(Qf^theta2);  
  
Q    = exp((u(+1)+dc(+1))*(1-gam1));  
logQ = log(Q);  
  
Qf    = exp((uf(+1)+dcf(+1))*(1-gam2));  
logQf = log(Qf);  
  
s = s(-1) + m - mf + dc -dcf;  
de =  ec; //This eq is just to have a "de" variable 
  
exp(m) = del*exp(- dc/ies1)*exp((u+dc)*(1/ies1-gam1))/exp(logQ(-1)*(1-theta1));  
exp(mf) = del*exp(- dcf/ies2)*exp((uf+dcf)*(1/ies2-gam2))/exp(logQf(-1)*(1-theta2));  
  
1/exp(rf) = exp(m(+1));  
1/exp(rff) = exp(mf(+1));  
1 = exp(m(+1)+rd(+1));  
exp(rd) = (1+exp(pd))/exp(pd(-1))*exp(dd);  
1 = exp(mf(+1)+rdf(+1));  
exp(rdf) = (1+exp(pdf))/exp(pdf(-1))*exp(ddf);  
rdex = rd - rfbar; // This eq is just to have a "rdex" variable  
end;  
  
initval;  
dy=mu;  
dyf=mu;  
de=0;  
x=xbar;  
xf=xbar;  
dc=mu;  
dcf=mu;  
dd=mu;  
ddf=mu;  
Q = Qbar1;  
Qf = Qbar2;  
logQ = logQbar1;  
logQf = logQbar2;  
u  = ubar;  
uf = ubarf;  
f  = fbar;  
ff = ffbar;  
s = sbar;  
pd = pdbar;  
rd = rfbar;  
rdex = 0;  
pdf = pdbar;  
rdf = rfbar;  
rf = rfbar;  
rff = rfbarf;  
m  = -rfbar;  
mf = -rfbar;  
end;  
  
vcov = [3.496900e-04	1.223915e-04	0	0  
        1.223915e-04	3.496900e-04	0	0  
        0	0  0.000000e+00  0.000000e+00  
        0	0  0.000000e+00  0.000000e+00  ];
  
 order = 3.000000; 
