%%%%%%%%%%%%%%%%%%%%%
%% Initial guesses %%
%%%%%%%%%%%%%%%%%%%%%
%% Guess on utilities
%% The ordering of states is
%%1. (XH,YL), 2. (XH,YH), 3. (XL,YL), 4. (XL,YH)
for s=1:S
    for m=2:N_mu-1
        c(s,m,1)=(1-del)*log( (k*(w_vec(m)/(1-w_vec(m)))/(1+k*(w_vec(m)/(1-w_vec(m))))*e(s,1))^(alp)*...
            ((w_vec(m)/(1-w_vec(m)))/(k+(w_vec(m)/(1-w_vec(m))))*e(s,2))^(1-alp));
        c(s,m,2)=(1-del)*log( (1/(1+k*(w_vec(m)/(1-w_vec(m))))*e(s,1))^(1-alp)*...
            (k/(k+(w_vec(m)/(1-w_vec(m))))*e(s,2))^(alp));
        

    end
    
        c(s,1,1)=0; %% This is actually -Inf, but it will get a zero weight in Q
        c(s,N_mu,1)=(1-del)*log( e(s,1)^(alp)*e(s,2)^(1-alp));
        c(s,1,2)=(1-del)*log( e(s,1)^(1-alp)*e(s,2)^(alp));
        c(s,N_mu,2)=0; %% This is actually -Inf, but it will get a zero weight in Q
    
end
        



for i=1:2 %% loop on agents
    for s=1:S %% loop on states
        U(s,1:N_mu,i)=c(s,:,i)/(1-del);
    end
end
%% Guess on mu
for s=1:S %% loop on states
        w_vec_p(s,1:N_mu)=w_vec;
end

%load init_guess


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Start value function iterations %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
diff=1; diff_disp=0.1; iter=1; itermax=100000;
disp('Value function iterations for inital guess')
while diff>1.0e-20 & iter<itermax
    
    %%%%% Store old info
    U_old=U;
    w_vec_old=w_vec;
    

    %% Let's use interp1 for the points where mu is on the grid
    for i=1:2
        for s=1:S
            Up(s,:,i)=interp1(w_vec(1,:),U(s,:,i),w_vec_p(s,:),'linear');
        end
    end
       

    
    %%%%% Expected continuation utilities
    for m=1:N_mu
        EU(1,m,1)=exp(Up(:,m,1)/th)'*p;
        EU(1,m,2)=exp(Up(:,m,2)/th)'*p;
    end
    
    %%%%% Total utilities
    for i=1:2
        for s=1:S
            for m=1:N_mu
                U(s,m,i)=c(s,m,i)+del*th*log(EU(1,m,i));
            end
        end
    end
   
    
    %%%%%% Update mu
    %mu=mu_grid;

    


    %%%%%% Update convergence criterion
    a=1; b=N_mu;
    diff=max(max(max(abs(U(:,a:b,:)-U_old(:,a:b,:)))));

    disp(diff)
    iter=iter+1;
    
end %% Exit value function iterations

for s=1:S
Q(s,:)=real(w_vec.*U(s,:,1)+(1-w_vec).*U(s,:,2));
end

disp('Initialization complete')
disp(' ')



