%% Housekeeping %%%%%
clear all; close all;
%%%%%%%%%%%%%%%%%%%%%
%% Model's parameters
%%%%%%%%%%%%%%%%%%%%%
gam=25;
th=1/(1-gam);
alp=0.98; k=alp/(1-alp);
del=.95;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Vector of Pareto weights
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N_mu=50001;
grid_num=10000; %100
w_vec=linspace(0,1,N_mu);
step=200; %% This is the number of nodes in each mini-loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Endowments
%%%%%%%%%%%%%%%%%%%%%%%%%%%
X = [103 100 60]; 
X = [103 100 60];
%% Matrix of endowments
% for s1=1:size(X,2)
%     for s2=1:size(X,2)
%         e((s1-1)*size(X,2)+s2,:)=[X(s1) X(s2)];
%     end
% end
e=[103   103;
   103   100;
   100   103;
   100   100;
    60    60];
S=size(e,1);
%% Probability of state vector
% p = [.25; .25; .25; .25];
p_r=5/100;
p_nr=(1-p_r)/4;
p = [p_nr p_nr p_nr p_nr p_r]';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Inital guess for Planner's utility
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run initialize
%% The first and last points are easy to compute since the Pareto weight
%% does not change over time there
Q_low=Q(:,1);
Q_top=Q(:,N_mu);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Global variables: these are some options for the various optimizations
%% in the program
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global options eps_der;
incr=1.0e-15;
eps_der=1.0e-5;
%% We cannot save the options so they need to appear in every loop
%% program!!!
options=optimset('TolX',incr,'TolFun',incr,'Display','off');
warning off MATLAB:divideByZero
%%%%%%%%%%%%%%%%%%%%%%%%%
%% Save stuff
U1=U(:,:,1); U2=U(:,:,2);
U1_old=U1; U2_old=U2;
save U1.txt U1 -ascii -double
save U2.txt U2 -ascii -double
save U1_old.txt U1_old -ascii -double
save U2_old.txt U2_old -ascii -double
save Q.txt Q -ascii -double
save Q_old.txt Q -ascii -double
save Q_low.txt Q_low -ascii -double
save Q_top.txt Q_top -ascii -double
save incr.txt incr -ascii -double
save eps_der.txt eps_der -ascii -double
save p.txt p -ascii -double
save S.txt S -ascii -double
save e.txt e -ascii -double
save w_vec.txt w_vec -ascii -double
save N_mu.txt N_mu -ascii -double
save grid_num.txt grid_num -ascii -double
save gam.txt gam -ascii -double
save th.txt th -ascii -double
save del.txt del -ascii -double
save k.txt k -ascii -double
save alp.txt alp -ascii -double
save step.txt step -ascii -double